/*
 * Extra operator chat room - HeXHub sample plugin code
 * Written by Morten Larsen, bluebear dot dk at gmail dot com
 * (C) Copyright 2007  Morten Larsen
 * License: Free without any restrictions other that you cant sue me
 *
 * This plugin was requested by Takel, who wanted a chatroom for OPs
 * where no messages from the hub was posted.
 *
 * All connected clients that have info1 right will join this room.
 */

#include <windows.h>
#include "HeXHuB.h"
#include <sstream>

// change this line if you want to alter the nickname of the chat room
const char *chatroomnick = "ضHT";

long botid = -1;

void HEXHUBAPI onPM(long bid, long uid, char *buf ,int size) {
	long long rights;
	char nick[41];
	std::stringstream os;
	long *ids;
	long l, uc;

	if (bid != botid) return;
	if (size < 2) return;

	if (HexHubFunctions::GetRights(uid, &rights) == false) return;

	if ((rights & BIT64_15) == false) { // check for info1 right
		if (HexHubFunctions::ClientNickFromId(uid, nick) == true) {
			os << "User '" << nick << "' without info1 right tryed to send a message to opchat.";
			HexHubFunctions::SendNotificationMessage(os.str().c_str());
		}
		return; 
	}

	uc = HexHubFunctions::GetUserCount();
	if (uc < 1) return;
	ids = new long [uc+51];
	if (ids == 0) return;
	uc = HexHubFunctions::GetUserIds(ids, uc+50);
	if (uc < 1) {
		delete [] ids;
		return;
	}

	char *cpy = new char [size];
	if (cpy == 0) {
		delete [] ids;
		return;
	}
	
	memcpy(cpy, buf, size);
	cpy[size-1] = 0;

	for (l=0; l<uc; l++) {
		if (ids[l] != uid) {
			if (HexHubFunctions::GetRights(ids[l], &rights) == true) {
				if (rights & BIT64_15) { // check for info1 right
					if (HexHubFunctions::ClientNickFromId(ids[l], nick) == true) {
						os.str("");
						os << "$To: " << nick << " From: " << chatroomnick << " $" << cpy << "|";
						HexHubFunctions::SendTo(ids[l], os.str().c_str(), os.str().length());
					}
				}
			}
		}
	}

	delete [] cpy;
	delete [] ids;
}

const char * HEXHUBAPI InitPlugin(lpfnGetFunction HexGetFunction) {
	HexHubFunctions hhf;
	if (hhf.Init(HexGetFunction) == false) return 0;

	botid = HexHubFunctions::RegisterBot(chatroomnick, (FARPROC)onPM);
	if (botid == -1) return 0;

	return "Takels ChatRoom - Written by bluebear";
}

void HEXHUBAPI UnloadPlugin(void) {
	if (botid != -1) HexHubFunctions::UnregisterBot(botid);
}